Sign Up

Sign Up to our social questions and Answers Engine to ask questions, answer people’s questions, and connect with other people.

Have an account? Sign In

Have an account? Sign In Now

Sign In

Login to our social questions & Answers Engine to ask questions answer people’s questions & connect with other people.

Sign Up Here

Forgot Password?

Don't have account, Sign Up Here

Forgot Password

Lost your password? Please enter your email address. You will receive a link and will create a new password via email.

Have an account? Sign In Now

You must login to ask a question.

Forgot Password?

Need An Account, Sign Up Here

Please briefly explain why you feel this question should be reported.

Please briefly explain why you feel this answer should be reported.

Please briefly explain why you feel this user should be reported.

Sign InSign Up

The Archive Base

The Archive Base Logo The Archive Base Logo

The Archive Base Navigation

  • SEARCH
  • Home
  • About Us
  • Blog
  • Contact Us
Search
Ask A Question

Mobile menu

Close
Ask a Question
  • Home
  • Add group
  • Groups page
  • Feed
  • User Profile
  • Communities
  • Questions
    • New Questions
    • Trending Questions
    • Must read Questions
    • Hot Questions
  • Polls
  • Tags
  • Badges
  • Buy Points
  • Users
  • Help
  • Buy Theme
  • SEARCH
Home/ Questions/Q 8159865
In Process

The Archive Base Latest Questions

Editorial Team
  • 0
Editorial Team
Asked: June 6, 20262026-06-06T18:03:52+00:00 2026-06-06T18:03:52+00:00

In ksh shell, I wanna to check the return value after running a command,

  • 0

In ksh shell, I wanna to check the return value after running a command, I’ve wrote two styles:

if [ $? -ne 0 ] ; then
    echo "failed!"
    exit 1
else
    exit 0
fi


[ $? -ne 0 ] && echo "failed!" && exit 1

Are they equivalent? If not, what could I do if I wanna to write it in one line?

  • 1 1 Answer
  • 0 Views
  • 0 Followers
  • 0
Share
  • Facebook
  • Report

Leave an answer
Cancel reply

You must login to add an answer.

Forgot Password?

Need An Account, Sign Up Here

1 Answer

  • Voted
  • Oldest
  • Recent
  • Random
  1. Editorial Team
    Editorial Team
    2026-06-06T18:03:54+00:00Added an answer on June 6, 2026 at 6:03 pm

    They’re close, but not the same. First, the if will execute the exit 1 even if the echo failed for some reason; the chained expression won’t. Also, the chained version lacks an equivalent of the else exit 0.

    A better equivalent would be this:

    [ $? -ne 0 ] && { echo "failed!"; exit 1; } || exit 0
    

    This is tagged ksh, so you might find the numeric expression syntax cleaner:

    (( $? )) && { echo "failed!"; exit 1; } || exit 0
    

    But you can also write an if on one line, if you like:

    if (( $? )); then echo "failed!"; exit 1; else exit 0; fi
    

    If the command that you just ran above this expression in order to set $? is short, you may want to just use it directly as the if expression – with reversed clauses, since exit code 0 is true:

    if grep -q "pattern" /some/filename; then exit 0; else echo "failed!"; exit 1; fi
    

    It doesn’t matter for this simple case, but in general you probably want to avoid echo. Instead, use printf – or if you don’t mind being ksh-only, you can use print. The problem with echo is that it doesn’t provide a portable way to deal with weird strings in variables:

    $ x=-n
    $ echo "$x"
    $ 
    

    While both printf and print do:

    $ printf '%s\n' "$x"
    -n
    $ print - "$x"
    -n
    

    Again, not a problem here, or any time you’re just printing out a literal string, but I found it was easier to train myself out of the echo habit entirely.

    • 0
    • Reply
    • Share
      Share
      • Share on Facebook
      • Share on Twitter
      • Share on LinkedIn
      • Share on WhatsApp
      • Report

Sidebar

Related Questions

i am testing with the shell script below: #!/bin/ksh -x instance=`echo $1 | cut
I want to do this in a shell script: #!/usr/bin/ksh PERL_PATH=/usr/local/bin/perl RET1=$(${PERL_PATH} missing_months_wrap.pl) echo
I'm working with an embedded system running QNX that has a stripped-down shell (KSH).
#!/bin/ksh ########################################################################## $JAVA_HOME/bin/java -jar SocketListener.jar 8182 run_something_else exit 0 SocketListener is started, and shell
#!/bin/ksh ######################### for i in {1..30} ;do echo $i done output is: {1..30} What
I am attempting to run the following command in KornShell (ksh): set -A INDEXES
I manage a large number of shell (ksh) scripts on server A. Each script
who do i run/execute a unix shell(ksh) script which isaved on my Windows Xp
#!/bin/ksh is the first line in a shell script always what is the importance
I need a good reference on unix shell special variables (csh, ksh and bash).

Explore

  • Home
  • Add group
  • Groups page
  • Communities
  • Questions
    • New Questions
    • Trending Questions
    • Must read Questions
    • Hot Questions
  • Polls
  • Tags
  • Badges
  • Users
  • Help
  • SEARCH

Footer

© 2021 The Archive Base. All Rights Reserved
With Love by The Archive Base

Insert/edit link

Enter the destination URL

Or link to existing content

    No search term specified. Showing recent items. Search or use up and down arrow keys to select an item.